import java.io.*;
import java.util.ArrayList;

public class Scanner {

	public ArrayList lexems = new ArrayList();
	ArrayList vars = new ArrayList();
	ArrayList var_types = new ArrayList();
	ArrayList var_vals = new ArrayList();
	private int pos = 0;
	private int place = 0;
	private int main_begin = 0;
	public Scanner(String filename) throws Exception {

		File file = new File(filename);
		FileInputStream filein = new FileInputStream(file);

		// tablica lexemow
		lexems = new ArrayList();

		// obecny lexem
		StringBuffer value = new StringBuffer();

		// obecny typ lexemu
		byte type = 0;

		// obecna linia
		int line = 1;

		// obecna kolumna
		int column = 1;

		// poczatek lexemu
		int began = 1;
		
		// poczatek stringa
		int sline = 1;

		int bite = filein.read();
		while (bite != -1) {
			if (bite == 34) { // " 
				if (type != 0) {
					lexems.add(new Lexem(value, type, line, began));
					value = new StringBuffer();
				}
				if (type != 5) {
					type = 5;
					began = column;
					sline = line;
				}
				else
					type = 0;
			}
			else if (type == 5) {
				value.append((char)bite);
				if (bite == 13) { // \n
					line ++;
					column = -1;
				}
			}
			// jesli liczba
			else if ((bite >= 48) && (bite <= 57)) {
				if (type == 0) {
					type = 1;	//type=1 liczba
					began = column;
				}
				value.append((char)bite);
			}
			else
				// jesli litera
				if (((bite >= 65) && (bite <= 90)) ||
					((bite >= 97) && (bite <= 122))) {
					if (type == 0) {
						type = 3;	//type=3 slowa
						began = column;
						value.append((char)bite);
					}
					else
						if (type == 3)
							value.append((char)bite);
					else {
							type = 7;
							break;
						}
				}
				else
					// jesli znak
					if (((bite >= 40) && (bite <= 45)) ||
						 (bite == 47) ||
						((bite >= 58) && (bite <= 62))) {
						if (type != 0) {
							lexems.add(new Lexem(value, type, line, began));
							type = 0;
							value = new StringBuffer();
						}
						lexems.add(new Lexem(bite, 4, line, column));
					}
					else
						// jesli kropka
						if (bite == 46)
							if (type != 0)
								if (type == 3)
									if (((value.toString())
										  .toUpperCase()).equals("END")) {
										lexems.add(new Lexem("END.",
												   (byte)3, line, began));
										type = 0;
										value = new StringBuffer();
									}
									else {	type = 8;
										break;}
								else
									if (type == 1) {
										type = 2;
										value.append('.');
									}
									else {	type = 8;
										break;}
							else {	type = 8;
										break;}
						else
							// jesli separator
							if ((bite ==  9) || (bite == 32) ||
								(bite == 13) || (bite == 10)) {
									if (type != 0) {
										lexems.add(new Lexem(value,
												   type, line, began));
										type = 0;
										value = new StringBuffer();
									}
									if (bite == 13) {
										line ++;
										column = -1;
									}
								}
							// jesli nie akcyptowany znak
							else {
								type = 9;
								break;
							}
			bite = filein.read();
			if ((bite == -1) && (type == 5))
				type = 6;
			else if (bite == -1) 
				if (type != 0) {
					lexems.add(new Lexem(value, type, line, began));
					type = 0;
					value = new StringBuffer();
				}
			column ++;
		}

		// blad
		if (type == 6)
			System.out.println("ERROR: String nie zamkniety ! "
				+ "linia: " + sline + ", kolumna: " + began);
		else if (type == 7)
			System.out.println("ERROR: litera polaczona z liczba ! "
				+ "linia: " + line + ", kolumna: " + column);
		else
			if (type == 8)
				System.out.println("ERROR: kropka w zlym miejscu ! "
			  		+ "linia: " + line + ", kolumna: " + column);
			else
				if (type == 9)
					System.out.println("ERROR: nieprawidlowy znak !: "
						+ (char)bite
			  			+ " linia: " + line + ", kolumna: " + column);
				else {
					// jesli wsio OK
					printLexems(lexems);
					ArrayList AdvL = advScanning(lexems);
                	printAdvLexems(AdvL);
					// validation process
                	String tmp_result = checkStructure(AdvL);
         			System.out.println(tmp_result);

					
				}
	}// Scanner()

	public void printLexems(ArrayList lex) {
		System.out.println("\nLEXEMW: " + lex.size());
		System.out.println("Wartosc\tTYP\tLinia\tKolumna");
		Object[] lexems = lex.toArray();
		for (int i = 0; i < lexems.length; i ++) {
			Lexem lexem = (Lexem)lexems[i];
			System.out.println(lexem.value + "\t" + lexem.type + "\t"
							 + lexem.line + "\t" + lexem.column);
		}
		System.out.println();
	}// printLexems(ArrayList)
//----------------------------------------------------------------------------DODATKOWE KLASY
	public void printAdvLexems(ArrayList AdvLex) {
		System.out.println("\nLEXEMS: " + AdvLex.size());
		System.out.println("VALUE   CODE   LCATEGORY   "
						 + "HCATEGORY   LINE   COLUMN");
		Object[] AdvLexems = AdvLex.toArray();
		for (int i = 0; i < AdvLexems.length; i ++) {
			AdvLexem advlexem = (AdvLexem)AdvLexems[i];
			System.out.println(advlexem.value + "   " + advlexem.code + "   "
							 + advlexem.lcategory + "   " 
							 + advlexem.hcategory + "   "
							 + advlexem.line + "   " + advlexem.column);
		}
		System.out.println();
	}//wypiszLeksem(Arraylist)

	public ArrayList advScanning(ArrayList lexems) {
		ArrayList AdvLexems = new ArrayList();
		String value = "";
		Codes codes = new Codes();
		codes.fillLists();
		Lexem lexem = null;
		byte code = 0;
		byte lcategory = 0;
		byte hcategory = 0;
		
		int size = lexems.size();
		int i = 0;
		while (i < size) {
			lexem = (Lexem)lexems.get(i);
			
			// jesli leksem jest slowem
			if (lexem.type == codes.STRING)
				AdvLexems.add(new AdvLexem(lexem.value, codes.STRING,
							  codes.STRING, codes.STRING,
							  lexem.line, lexem.column));
			else if (lexem.type == codes.WORD) {
				hcategory = codes.WORD;
				code = codes.getKeywordCode(lexem.value);

				if (code == codes.VARIABLE)
					lcategory = codes.VARIABLE;
				else if ((code >= codes.INTEGER) && (code <= codes.REAL))
					lcategory = codes.VTYPE;					
				else
					lcategory = codes.KEYWORD;
				
				AdvLexems.add(new AdvLexem(lexem.value, code,
							  lcategory, hcategory,
							  lexem.line, lexem.column));
			}
			
			// jesli leksem jest znakiem
			else if (lexem.type == codes.SIGN) {
				value = lexem.value;;
				hcategory = codes.SIGN;
				code = codes.getSignCode(lexem.value);
				
				if ((code >= codes.COLON) && (code <= codes.QUOTATION)) {
					lcategory = codes.OOPERATOR;
					if (lexem.value.equals(":"))
						if ((i + 1) < size)
							if (((Lexem)lexems.get(i + 1)).value.equals("=")) {
								code = codes.ASOCIATE;
								value = ":=";
								i ++;
							}
				}
				else if ((code >= codes.E) && (code <= codes.LT)) {
					lcategory = codes.ROPERATOR;
				}
				else if ((code >= codes.PLUS) && (code <= codes.DIV)) {
					lcategory = codes.AOPERATOR;
				}
				AdvLexems.add(new AdvLexem(value, code,
							  lcategory, hcategory,
							  lexem.line, lexem.column));
			}
			else
				AdvLexems.add(new AdvLexem(lexem.value, lexem.type,
							  codes.NUMBER, codes.WORD,
							  lexem.line, lexem.column));
			i ++;
		}
		return AdvLexems;
	}

	private String errorMess(String expected, AdvLexem found) {
		return ("spodziewano: " + expected
			 + "\n   znaleziono: " + found.value
			 + "\n   linia: " + found.line
			 + "\n   kolumna: " + found.column);
	}

	private String errorMess(String expected) {
		return ("expected: " + expected
			 + "   nothing found");
	}
	
	
	// sprawdzamy czy jest leksem o podanym CODE
	private String checkC(String s, byte code, ArrayList AL) {
		if (pos < AL.size()) {
			AdvLexem al = (AdvLexem)AL.get(pos);
			if (al.code != code)
				return errorMess(s, al);
		}
		else
			return errorMess(s);
		return "";
	}

	private String checkC(String s, byte code, ArrayList AL, int which) {
		if (which < AL.size()) {
			AdvLexem al = (AdvLexem)AL.get(which);
			if (al.code != code)
				return errorMess(s, al);
		}
		else
			return errorMess(s);
		return "";
	}
	
	// sprawdzamy czy jest leksem o nizszej kategorii
	private String checkL(String s, byte code, ArrayList AL) {
		if (pos < AL.size()) {
			AdvLexem al = (AdvLexem)AL.get(pos);
			if (al.lcategory != code)
				return errorMess(s, al);
		}
		else
			return errorMess(s);
		return "";
	}
	
// mmmmmmmmmmmmmmmmmmm	skaner skladniowy	mmmmmmmmmmmmmmmmmmmmmmmmmmm
	
	public String checkStructure(ArrayList AL) {		
		Codes codes = new Codes();
		codes.fillLists();
		String result = "";
		AdvLexem al;
		int size = AL.size();
		result = checkC("PROGAM", codes.PROGRAM, AL);
		if (!(result.equals("")))
			return result;
		pos ++;
		result = checkC("nazwa programu", codes.VARIABLE, AL);
		if (!(result.equals("")))
			return result;
		pos ++;
		// AdvLexem al2 = (AdvLexem)AL.get(pos);
		// System.out.println(al2.code);
		result = checkC("srednik", codes.SEMICOLON, AL);
		if (!(result.equals("")))
			return result;
		pos ++;
		result = checkC("VAR", codes.VAR, AL);
		if (!(result.equals(""))) {
			result = checkC("VAR lub BEGIN", codes.BEGIN, AL);
			if (!(result.equals("")))
				return result;
		}
		if ((((AdvLexem)AL.get(pos)).value).equals("VAR")) {
			pos ++;
			result = checkVAR(AL);
			if (!(result.equals("")))
				return result;
		}

		// sprawdzamy czy jest END. na koncu programu
		if (AL.size() - 1 > pos) {
			result = checkC("END.", Codes.END_DOT, AL, AL.size() - 1);
			if (!(result.equals("")))
				return result;
		}
		else
			return "spodziewano: END. na koncu programu ";

		// sprawdzamy czy wszystkie zmienne sa zadeklarowane
		for (int i = pos + 1; i < AL.size() - 2; i ++) {
			al = (AdvLexem)(AL.get(i));
			if (al.code == Codes.VARIABLE)
				if (!(vars.contains(al.value)))
					return "nie zadeklarowano zmiennej " + al.value
						 + "\n   linia: " + al.line
						 + "\n   kolumna: " + al.column;
		}
		
		pos ++;
		main_begin = pos;
		result = checkBody(AL);

		
		if (!(result.equals("")))
			return result;

		return "Brak bledow :-D!";
	}

	private String checkVAR(ArrayList AL) {
		byte var_count = 0;
		String result = "";
		AdvLexem al = null;
		// jesli BEGIN zmieniamy wartosc na TRUE
		boolean finish_b = false;
		// jesli nie ma przecinka to zmien na TRUE
		boolean finish_c = false;

		while (!finish_b) {
			result = checkC("BEGIN", Codes.BEGIN, AL);
			// jesli jeszcze nie ma BEGIN
			if (!result.equals("")) {
				result = checkC("Zmienna", Codes.VARIABLE, AL);
				// jesli jest zmienna
				if (!result.equals(""))
					return result;
				al = (AdvLexem)AL.get(pos);
				if ((((AdvLexem)AL.get(1)).value).equals(al.value))
					return "Zmienna jest juz uzyta jako nazwa programu"
						 + "\n   line: " + al.line
						 + "\n   column: " + al.column;
				if (vars.contains(al.value))
					return ("Zmienna juz zadeklarowana: " + al.value
						 + "\n   linia: " + al.line
						 + "\n   kolumna: " + al.column);
				vars.add(al.value);
				var_count ++;
				finish_c = false;
				while (!finish_c) {
					pos ++;
					result = checkC("Przecinek", Codes.COMMA, AL);
					if (result.equals("")) {
						pos ++;
						result = checkC("Zmienna", Codes.VARIABLE, AL);
						if (!result.equals(""))
							return result;
						al = (AdvLexem)AL.get(pos);
						if ((((AdvLexem)AL.get(1)).value).equals(al.value))
							return "Nazwa zmienna jest juz uzyta jako nazwa programu "
								 + "\n   linia: " + al.line
								 + "\n   kolumna: " + al.column;
						if (vars.contains(al.value))
							return ("Zmienna jest juz zadeklarowana: " + al.value
								 + "\n   linia: " + al.line
								 + "\n   kolumna: " + al.column);
						vars.add(al.value);
						var_count ++;
					}
					else
						finish_c = true;
				}
				result = checkC("dwukropek", Codes.COLON, AL);
				if (!result.equals(""))
					return result;
				pos ++;
				result = checkL("Typ zmiennej", Codes.VTYPE, AL);
				if (!result.equals(""))
					return result;

				byte code = ((AdvLexem)AL.get(pos)).code;
				for (byte i = 0; i < var_count; i ++)
					var_types.add(new Integer(code));
				var_count = 0;
				
				pos ++;
				result = checkC("rednik:", Codes.SEMICOLON, AL);
				if (!result.equals(""))
					return result;	
				pos ++;	
			}
			else 
				finish_b = true;
		}
		return "";
	}

	private String checkIASSOC(ArrayList AL) {
		String result = "";
		AdvLexem al = null;
		byte b_count = 0; // licznik nawiasow
		boolean finish_b = false; // zakoncz jesli nie ma nawiasow

		while (!finish_b) {
			result = checkC("nawias", Codes.LBRACKET, AL);
			if (!result.equals(""))
				finish_b = true;
			else {
				b_count ++;
				pos ++;
			}
		}
		result = checkC("minus", Codes.MINUS, AL);
		if (result.equals("")) {
			pos ++;
			result = checkC("liczba integer", Codes.INUMBER, AL);
			if (result.equals("")) {
				al = (AdvLexem)AL.get(pos);
				AL.set(pos - 1, new AdvLexem("-" + al.value, al.code,
											  al.lcategory, al.hcategory,
											  al.line, al.column));
				AL.remove(pos);
			}
			else
				return result;
		}
		else {
			result = checkC("Liczba integer", Codes.INUMBER, AL);
			if (!result.equals("")) {
				result = checkC("zmienna ineger", Codes.VARIABLE, AL);
				if (!result.equals(""))
					return result;			
				else {
					al = (AdvLexem)AL.get(pos);
					int tmp = vars.indexOf(al.value);
					if (!(((Integer)var_types.get(tmp)).equals(
										new Integer(Codes.INTEGER)))) {
						al = (AdvLexem)AL.get(pos);
						return "Oczekiwano zmienna typu integer: "
							 + "\n   znaleziono: " + al.value
							 + "\n   linia: " + al.line
							 + "\n   kolumna: " + al.column;
					}
					else
						pos++;
				}
			}
			else
				pos ++;
		}
		finish_b = false;
		while (!finish_b) {
			result = checkC("OPERATOR", Codes.RBRACKET, AL);
			if (!result.equals(""))
				finish_b = true;
			else {
				if (b_count > 0) {
					b_count --;
					pos ++;
				}
				else {
					al = (AdvLexem)AL.get(pos);
					return "Nie otwarto prawego nawiasu:" 
							 + "\n   line: " + al.line
							 + "\n   column: " + al.column;
				}
			}
		}
		boolean finish_o = false; // jesli nie ma operatorow
		while (!finish_o){
			result = checkL("Operator arytmetyczny", Codes.AOPERATOR, AL);
			if (!result.equals(""))
				finish_o = true;
			else {
				pos ++;
				finish_b = false;
				while (!finish_b) {
					result = checkC("nawias", Codes.LBRACKET, AL);
					if (!result.equals(""))
						finish_b = true;
					else {
						b_count ++;
						pos ++;
					}
				}
				result = checkC("minus", Codes.MINUS, AL);
				if (result.equals("")) {
					pos ++;
					result = checkC("Liczba integer", Codes.INUMBER, AL);
					if (result.equals("")) {
						al = (AdvLexem)AL.get(pos);
						AL.set(pos - 1, new AdvLexem("-" + al.value, al.code,
													  al.lcategory,
													  al.hcategory,
													  al.line, al.column));
						AL.remove(pos);
					}
					else
						return result;
				}
				else {
					result = checkC("liczna integer", Codes.INUMBER, AL);
					if (!result.equals("")) {
						result = checkC("zmienna integer", Codes.VARIABLE, AL);
						if (!result.equals(""))
							return result;			
						else {
							al = (AdvLexem)AL.get(pos);
							int tmp = vars.indexOf(al.value);
							if (!(((Integer)var_types.get(tmp)).equals(
												new Integer(Codes.INTEGER)))) {
								al = (AdvLexem)AL.get(pos);
								return "Oczekiwano zmienna typu integer "
									 + "\n   znaleziono: " + al.value
									 + "\n   linia: " + al.line
									 + "\n   kolumna: " + al.column;
							}
							else
								pos++;
						}
					}
					else
						pos ++;
				}
				finish_b = false;
				while (!finish_b) {
					result = checkC("OPERATOR", Codes.RBRACKET, AL);
					if (!result.equals(""))
						finish_b = true;
					else {
						if (b_count > 0) {
							b_count --;
							pos ++;
						}
						else {
							al = (AdvLexem)AL.get(pos);
							return "Nie otwarto Prawego nawiasu"
									 + "\n   linia: " + al.line
									 + "\n   kolumna: " + al.column;
						}
					}
				}				
			}
		}
		
		return "";
	}
	
	private String checkRASSOC(ArrayList AL) {
		String result = "";
		AdvLexem al = null;
		byte b_count = 0; // licznik nawiasow
		boolean finish_b = false; // konczy jesli nie ma juz nawaisow

		while (!finish_b) {
			result = checkC("nawias", Codes.LBRACKET, AL);
			if (!result.equals(""))
				finish_b = true;
			else {
				b_count ++;
				pos ++;
			}
		}
		result = checkC("minus", Codes.MINUS, AL);
		if (result.equals("")) {
			pos ++;
			result = checkC("liczba integer lub real", Codes.INUMBER, AL);
			if ((result.equals("")) ||
				(checkC("", Codes.RNUMBER, AL).equals(""))) {
				al = (AdvLexem)AL.get(pos);
				AL.set(pos - 1, new AdvLexem("-" + al.value, al.code,
											  al.lcategory, al.hcategory,
											  al.line, al.column));
				AL.remove(pos);
			}
			else
				return result;
		}
		else {
			result = checkC("", Codes.INUMBER, AL);
			if (!((result.equals("")) ||
				(checkC("", Codes.RNUMBER, AL).equals("")))) {
				result = checkC("liczba integer lub real",
								 Codes.VARIABLE, AL);
				if (!result.equals(""))
					return result;
				else {
					al = (AdvLexem)AL.get(pos);
					int tmp = vars.indexOf(al.value);
					int type = ((Integer)var_types.get(tmp)).intValue();
					if (!((type == Codes.INTEGER) || (type == Codes.REAL))) {
						al = (AdvLexem)AL.get(pos);
						return "oczekiwano liczbe integer lub real "
							 + "\n   znaleziono: " + al.value
							 + "\n   linia: " + al.line
							 + "\n   kolumna: " + al.column;
					}
					else
						pos++;
				}
			}
			else
				pos ++;
		}
		finish_b = false;
		while (!finish_b) {
			result = checkC("OPERATOR", Codes.RBRACKET, AL);
			if (!result.equals(""))
				finish_b = true;
			else {
				if (b_count > 0) {
					b_count --;
					pos ++;
				}
				else {
					al = (AdvLexem)AL.get(pos);
					return "Prawy nawias nie otwarty "
							 + "\n   line: " + al.line
							 + "\n   column: " + al.column;
				}
			}
		}
		boolean finish_o = false; //jesli nie ma operatorow
		while (!finish_o){
			result = checkL("zamkniety nawias", Codes.AOPERATOR, AL);
			if (!result.equals("")) {
				finish_o = true;
				if (b_count > 0)
				return result;
			}
			else {
				pos ++;
				finish_b = false;
				while (!finish_b) {
					result = checkC("nawias", Codes.LBRACKET, AL);
					if (!result.equals(""))
						finish_b = true;
					else {
						b_count ++;
						pos ++;
					}
				}
				result = checkC("minus", Codes.MINUS, AL);
				if (result.equals("")) {
					pos ++;
					result = checkC("liczba integer lub real",
									 Codes.INUMBER, AL);
					if ((result.equals("")) ||
						(checkC("", Codes.RNUMBER, AL).equals(""))) {
						al = (AdvLexem)AL.get(pos);
						AL.set(pos - 1, new AdvLexem("-" + al.value, al.code,
													  al.lcategory,
													  al.hcategory,
													  al.line, al.column));
						AL.remove(pos);
					}
					else
						return result;
				}
				else {
					result = checkC("", Codes.INUMBER, AL);
					if (!((result.equals("")) ||
						(checkC("", Codes.RNUMBER, AL).equals("")))) {
						result = checkC("liczba integer lub real",
										 Codes.VARIABLE, AL);
						if (!result.equals(""))
							return result;			
						else {
							al = (AdvLexem)AL.get(pos);
							int tmp = vars.indexOf(al.value);
							int type = ((Integer)var_types.get(tmp))
																.intValue();
							if (!((type == Codes.INTEGER) ||
								 (type == Codes.REAL))) {
								al = (AdvLexem)AL.get(pos);
								return "oczekiwano liczbe integer lub real "
									 + "\n   found: " + al.value
									 + "\n   line: " + al.line
									 + "\n   column: " + al.column;
							}
							else
								pos++;
						}
					}
					else
						pos ++;
				}
				finish_b = false;
				while (!finish_b) {
					result = checkC("OPERATOR", Codes.RBRACKET, AL);
					if (!result.equals(""))
						finish_b = true;
					else {
						if (b_count > 0) {
							b_count --;
							pos ++;
						}
						else {
							al = (AdvLexem)AL.get(pos);
							return "Prawy nawias nie otarty"
									 + "\n   linia: " + al.line
									 + "\n   kolumna: " + al.column;
						}
					}
				}				
			}
		}		
		return "";
	}
	private String checkLEXPR(ArrayList AL) {
		String result = "";
		AdvLexem al = null;
		byte b_count = 0; // licznik nawiasow
		boolean finish_o = false;
		boolean finish_n = false;
		boolean finish_b = false;		

		 while (!finish_n) {
			finish_b = false;
			while (!finish_b) {
				result = checkC("VALUE", Codes.LBRACKET, AL);
				if (!result.equals(""))
					finish_b = true;
				else {
					b_count ++;
					pos ++;
				}
			}
			result = checkC("NOT", Codes.NOT, AL);
			if (!result.equals(""))
				finish_n = true;
			else
				pos ++;
			}
		result = checkLEXPRNElem(AL);
		if (result.equals("")) {
			result = checkL("Operator logiczny",
							 Codes.ROPERATOR, AL);
			if (!result.equals(""))
				return result;
			else {
				pos ++;
				result = checkLEXPRNElem(AL);
				if (!result.equals(""))
					return result;
			}
		}
	/*	else {
			result = checkLEXPRLElem(AL);
			if (!result.equals(""))
				return result;
		}*/
		finish_b = false;
		while (!finish_b) {
			result = checkC("OPERATOR", Codes.RBRACKET, AL);
			if (!result.equals(""))
				finish_b = true;
			else {
				if (b_count > 0) {
					b_count --;
					pos ++;
				}
				else {
					al = (AdvLexem)AL.get(pos);
					return "Prawy nawias nie otwarty"
							 + "\n   linia: " + al.line
							 + "\n   kolumna: " + al.column;
				}
			}
		}
		finish_o = false;
		while (!finish_o){
			result = checkL("zamkniecie nawiasu", Codes.LOPERATOR, AL);
			if (!result.equals("")) {
				finish_o = true;
				if (b_count > 0)
				return result;
			}
			else {
				pos ++;
				finish_n = false;
				while (!finish_n) {
					finish_b = false;
					while (!finish_b) {
						result = checkC("VALUE", Codes.LBRACKET, AL);
						if (!result.equals(""))
							finish_b = true;
						else {
							b_count ++;
							pos ++;
						}
					}
					result = checkC("NOT", Codes.NOT, AL);
					if (!result.equals(""))
						finish_n = true;
					else
						pos ++;
				}
				result = checkLEXPRNElem(AL);
				if (result.equals("")) {
					result = checkL("operator logiczny",
									 Codes.ROPERATOR, AL);
					if (!result.equals(""))
						return result;
					else {
						pos ++;
						result = checkLEXPRNElem(AL);
						if (!result.equals(""))
							return result;
					}
				}
		/*		else {
					result = checkLEXPRLElem(AL);
					if (!result.equals(""))
						return result;
				}*/
				finish_b = false;
				while (!finish_b) {
					result = checkC("OPERATOR", Codes.RBRACKET, AL);
					if (!result.equals(""))
						finish_b = true;
					else {
						if (b_count > 0) {
							b_count --;
							pos ++;
						}
						else {
							al = (AdvLexem)AL.get(pos);
							return "Prawy nawias nie otwarty"
									 + "\n   linia: " + al.line
									 + "\n   kolumna: " + al.column;
						}
					}
				}
			}
		}
		return "";
	}
	
	private String checkWRITE(ArrayList AL) {
		String result = "";
		AdvLexem al = null;
		result = checkC("Lewy nawias", Codes.LBRACKET, AL);
		if (!result.equals(""))
			return result;
		pos ++;
		result = checkC("lancuch znakow lub zmienna", Codes.STRING, AL);
		if (!(result.equals("") ||
			(checkC("", Codes.VARIABLE, AL)).equals("")))
			return result;
		pos ++;
		boolean finish_c = false;
		while (!finish_c) {
			result = checkC("przecinek", Codes.COMMA, AL);
			if (!result.equals(""))
				finish_c = true;
			else {
				pos ++;
				result = checkC("lancuch znakow lub zmienna", Codes.STRING, AL);
				if (!(result.equals("") ||
					(checkC("", Codes.VARIABLE, AL)).equals("")))
					return result;
				else
					pos ++;			
			}
		}
		result = checkC("prawy nawias", Codes.RBRACKET, AL);
		if (!result.equals(""))
			return result;
		pos ++;
		return "";
	}// checkWRITE()
	
	private String checkREAD(ArrayList AL) {
		String result = "";
		AdvLexem al = null;
		result = checkC("lewy zawias", Codes.LBRACKET, AL);
		if (!result.equals(""))
			return result;
		pos ++;
		result = checkC("zmienna", Codes.VARIABLE, AL);		
		if (!result.equals(""))
			return result;
		pos ++;
		result = checkC("prawy nawias", Codes.RBRACKET, AL);
		if (!result.equals(""))
			return result;
		pos ++;		
		return "";
	}


//mmmmmmmmmmmmmmmmmm	GWNY Skaner skladniowy   mmmmmmmmmmmmmmmmmmmmmmmmmmmmmm
	
	private String checkBody(ArrayList AL) {
		String result = "";
		AdvLexem al = null;
		int begins = 0;

		while (true) {
			al = (AdvLexem)AL.get(pos);
			if (al.code == Codes.VARIABLE) {
				pos ++;
				result = checkC(":=", Codes.ASOCIATE, AL);
				if (!result.equals(""))
					return result;
				pos ++;
				int tmp = vars.indexOf(al.value);
				int type = ((Integer)var_types.get(tmp)).intValue();
				if (type == Codes.INTEGER) {
					result = checkIASSOC(AL);
					if (!result.equals(""))
						return result;
				}
				else if (type == Codes.REAL) {
					result = checkRASSOC(AL);
					if (!result.equals(""))
						return result;
				}
				result = checkEnding(AL);
				if (!result.equals(""))
					return result;
			}
			else if (al.code == Codes.WRITELN) {
				pos ++;
				result = checkWRITE(AL);
				if (!result.equals(""))
					return result;
				result = checkEnding(AL);
				if (!result.equals(""))
					return result;
			}
			else if (al.code == Codes.READLN) {
				pos ++;
				result = checkREAD(AL);
				if (!result.equals(""))
					return result;
				result = checkEnding(AL);
				if (!result.equals(""))
					return result;
			}
			else if (al.code == Codes.WHILE) {
				pos ++;
				result = checkLEXPR(AL);
				if (!result.equals(""))
					return result;
				result = checkC("slowo kluczowe DO", Codes.DO, AL);
				if (!result.equals(""))
					return result;
				pos ++;
				result = checkOne(AL);
				if (!result.equals(""))
					return result;				
			}
			else if (al.code == Codes.IF) {
				pos ++;
				result = checkLEXPR(AL);
				if (!result.equals(""))
					return result;
				result = checkC("slowo kluczowe THEN", Codes.THEN, AL);
				if (!result.equals(""))
					return result;
				pos ++;
				result = checkOne(AL);
				if (!result.equals(""))
					return result;
				result = checkC("slowo kluczowe ELSE", Codes.ELSE, AL);
				if (result.equals("")) {
					pos ++;
					result = checkOne(AL);
					if (!result.equals(""))
						return result;
				}
			}
			else if (al.code == Codes.BEGIN) {
				AL.remove(pos);
				result = checkBlock(AL);
				if (!result.equals(""))
					return result;
				else {
					pos --;
					result = checkC("srednik", Codes.SEMICOLON, AL);
					if (result.equals("")) {
						AL.remove(pos);
						pos --;
					}
					AL.remove(pos);

				}
			}
			else if (al.code == Codes.END) {
				return "END bez rozpoczynajacego BEGIN"
					 + "\n   znaleziono: " + al.value
					 + "\n   linia: " + al.line
					 + "\n   kolumna: " + al.column;	
			}
			else if (al.code == Codes.END_DOT) {
				return "";
			}
			else
				return "nieprawidlowe wyrazenie"
					 + "\n   znaleziono: " + al.value
					 + "\n   linia: " + al.line
					 + "\n   kolumna: " + al.column;
		}
	}	

	private String checkBlock(ArrayList AL) {
		String result = "";
		AdvLexem al = null;
		int begins = 0;

		while (true) {
			al = (AdvLexem)AL.get(pos); 
			if (al.code == Codes.VARIABLE) {
				pos ++;
				result = checkC("znak przypisania", Codes.ASOCIATE, AL);
				if (!result.equals(""))
					return result;
				pos ++;
				int tmp = vars.indexOf(al.value);
				int type = ((Integer)var_types.get(tmp)).intValue();
				if (type == Codes.INTEGER) {
					result = checkIASSOC(AL);
					if (!result.equals(""))
						return result;
				}
				else if (type == Codes.REAL) {
					result = checkRASSOC(AL);
					if (!result.equals(""))
						return result;
				}
				result = checkEnding(AL);
				if (!result.equals(""))
					return result;
			}
			else if (al.code == Codes.WRITELN) {
				pos ++;
				result = checkWRITE(AL);
				if (!result.equals(""))
					return result;
				result = checkEnding(AL);
				if (!result.equals(""))
					return result;
			}
			else if (al.code == Codes.READLN) {
				pos ++;
				result = checkREAD(AL);
				if (!result.equals(""))
					return result;
				result = checkEnding(AL);
				if (!result.equals(""))
					return result;
			}
			else if (al.code == Codes.WHILE) {
				pos ++;
				result = checkLEXPR(AL);
				if (!result.equals(""))
					return result;
				result = checkC("slowo kluczowe DO", Codes.DO, AL);
				if (!result.equals(""))
					return result;
				pos ++;
				result = checkOne(AL);
				if (!result.equals(""))
					return result;				
			}
			else if (al.code == Codes.IF) {
				pos ++;
				result = checkLEXPR(AL);
				if (!result.equals(""))
					return result;
				result = checkC("slowo kluczowe THEN", Codes.THEN, AL);
				if (!result.equals(""))
					return result;
				pos ++;
				result = checkOne(AL);
				if (!result.equals(""))
					return result;
				result = checkC("slowo kluczowe ELSE", Codes.ELSE, AL);
				if (result.equals("")) {
					pos ++;
					result = checkOne(AL);
					if (!result.equals(""))
						return result;
				}
			}
			else if (al.code == Codes.BEGIN) {
				pos ++;
				result = checkBlock(AL);
				if (!result.equals(""))
					return result;
			}
			else if (al.code == Codes.END) {
				pos ++;
				result = checkEnding(AL);
				if (!result.equals(""))
					return result;
				else
					return "";
			}
			else if (al.code == Codes.END_DOT) {
				return "oczekiwano END"
					 + "\n   linia: " + al.line
					 + "\n   kolumna: " + al.column;
			}
			else
				return "nieprawidlowe wyrazenie"
					 + "\n   znaleziono: " + al.value
					 + "\n   linia: " + al.line
					 + "\n   kolumna: " + al.column;
		}
	}

	private String checkOne(ArrayList AL) {
		String result = "";
		AdvLexem al = null;
		int begins = 0;
		al = (AdvLexem)AL.get(pos);
		if (al.code == Codes.VARIABLE) {

			pos ++;
			result = checkC("operator przypisania", Codes.ASOCIATE, AL);
			if (!result.equals(""))
				return result;
			pos ++;
			int tmp = vars.indexOf(al.value);
			int type = ((Integer)var_types.get(tmp)).intValue();

			if (type == Codes.INTEGER) {
				result = checkIASSOC(AL);
				if (!result.equals(""))
					return result;
			}
			else if (type == Codes.REAL) {
				result = checkRASSOC(AL);
				if (!result.equals(""))
					return result;
			}
			return checkEnding(AL);
		}
		else if (al.code == Codes.WRITELN) {
			pos ++;
			result = checkWRITE(AL);
			if (!result.equals(""))
				return result;
			return checkEnding(AL);
		}
		else if (al.code == Codes.READLN) {
			pos ++;
			result = checkREAD(AL);
			if (!result.equals(""))
				return result;
			return checkEnding(AL);
		}
		else if (al.code == Codes.WHILE) {
			pos ++;
			result = checkLEXPR(AL);
			if (!result.equals(""))
				return result;
			result = checkC("slowo kluczowe DO", Codes.DO, AL);
			if (!result.equals(""))
				return result;
			pos ++;
			return checkOne(AL);
		}
		else if (al.code == Codes.IF) { 
			pos ++;
			result = checkLEXPR(AL);
			if (!result.equals(""))
				return result;
			result = checkC("slowo kluczowe THEN", Codes.THEN, AL);
			if (!result.equals(""))
				return result;
			pos ++;

			result = checkOne(AL);
			if (!result.equals(""))
				return result;
			result = checkC("slowo kluczowe ELSE", Codes.ELSE, AL);
			if (result.equals("")) {
				pos ++;
				return checkOne(AL);
			}
			else
				return "";
		}
		else if (al.code == Codes.BEGIN) {
			pos ++;

			return checkBlock(AL);
		}
		else if (al.code == Codes.END) {
				return "END bez rozpoczynajacego BEGIN"
					 + "\n   znaleziono: " + al.value
					 + "\n   linia: " + al.line
					 + "\n   kolumna: " + al.column;					
		}
		else if ((al.code == Codes.END_DOT) || 
				 (al.code == Codes.ELSE)) {
			return "oczekiwano instrukcje" 
				 + "\n   linia: " + al.line
				 + "\n   kolumna: " + al.column;
		}
		else
			return "nieprawidlowe wyrazenie"
				 + "\n   znaleziono: " + al.value
				 + "\n   linia: " + al.line
				 + "\n   kolumna: " + al.column;
	}

	private String checkEnding(ArrayList AL) {
		String result = "";
		
		result = checkC("srednik", Codes.SEMICOLON, AL);
		if (!result.equals("")) {
			result = checkC("END", Codes.END, AL);
			if (!result.equals("")) {
				result = checkC("ELSE", Codes.ELSE, AL);
				if (!result.equals("")) {
					result = checkC("END.", Codes.END_DOT, AL);
					if (!result.equals(""))
						return result;
				}
			}
		}
		else
			pos ++;
		return "";
		
	}

	// sprawdzanie wyrazen logicznych
	private String checkLEXPRNElem(ArrayList AL) {
		String result = "";
		AdvLexem al = null;
		
		result = checkC("VALUE", Codes.MINUS, AL);
		if (result.equals("")) {
			pos ++;
			result = checkC("INTEGER OR REAL NUMBER",
							 Codes.INUMBER, AL);
			if ((result.equals("")) ||
				(checkC("", Codes.RNUMBER, AL).equals(""))) {
				al = (AdvLexem)AL.get(pos);
				AL.set(pos - 1, new AdvLexem("-" + al.value, al.code,
											  al.lcategory,
											  al.hcategory,
											  al.line, al.column));
				AL.remove(pos);
				return "";
			}
			else
				return result;
		}
		else {
			result = checkC("", Codes.INUMBER, AL);
			if (!((result.equals("")) ||
				(checkC("", Codes.RNUMBER, AL).equals("")))) {
				result = checkC("INTEGER OR REAL VARIABLE",
								 Codes.VARIABLE, AL);
				if (!result.equals(""))
					return result;
				else {
					al = (AdvLexem)AL.get(pos);
					int tmp = vars.indexOf(al.value);
					int type = ((Integer)var_types.get(tmp)).intValue();
					if (!((type == Codes.INTEGER) || (type == Codes.REAL))) {
						al = (AdvLexem)AL.get(pos);
						return "INTEGER OR REAL VARIABLE expected "
							 + "\n   found: " + al.value
							 + "\n   line: " + al.line
							 + "\n   column: " + al.column;
					}
					else {
						pos++;
						return "";
					}
				}
			}
			else {
				pos ++;
				return "";
			}
		}
	}
	
	
//-------------------------------------------------------------------------------------------
class Lexem {
	String value;
	byte type;
	int line;
	int column;

	public Lexem(String value, byte type, int line, int column) {
		if (type != Codes.STRING)
			this.value = value.toUpperCase();
		else
			this.value = value;
		this.type = type;
		this.line = line;
		this.column = column;
	}

	public Lexem(StringBuffer value, byte type, int line, int column) {
		if (type != Codes.STRING)
			this.value = value.toString().toUpperCase();
		else
			this.value = value.toString();
		this.type = type;
		this.line = line;
		this.column = column;
	}

	public Lexem(int value, int type, int line, int column) {
		char[] sign = new char[1];
		sign[0] = (char)value;
		this.value = new String(sign);
		this.type = (byte)type;
		this.line = line;
		this.column = column;
	}
}
class AdvLexem {
	String value;
	byte code;
	byte lcategory; // nizsza kategoria 
	byte hcategory; // wyzsza kategoria 
	byte ccategory; // inna kategoria jesli potrzebna 
	int line;
	int column;

	public AdvLexem(String value, byte code, byte lcategory,
					byte hcategory, int line, int column) {
		this.value = value;
		this.code = code;
		this.lcategory = lcategory;
		this.hcategory = hcategory;
		this.line = line;
		this.column = column;
	}
}

}
