import java.io.*;
import java.util.ArrayList;

public class Codes {

	// kody dla sw kluczowych
	static final byte PROGRAM   = 10;
	static final byte BEGIN     = 11;	
	static final byte END       = 12;
	static final byte END_DOT   = 13; // END.
	static final byte VAR       = 14;
	static final byte IF        = 15;
	static final byte THEN      = 16;
	static final byte ELSE      = 17;
	static final byte WHILE     = 18;
	static final byte DO        = 19;
	static final byte NOT       = 20;
	static final byte READLN    = 21;
	static final byte WRITELN   = 22;
	static final byte INTEGER   = 23;
	static final byte REAL      = 24;
	

	// kody dla znakw
	static final byte PLUS      = 25; // '+'
	static final byte MINUS     = 26; // '-'
	static final byte MULT      = 27; // '*'
	static final byte DIV       = 28; // '/'
	static final byte E         = 29; // '='

	static final byte GT        = 30; // '>'

	static final byte LT        = 31; // '<'
	static final byte COLON     = 32; // ':'
	static final byte SEMICOLON = 33; // ';'
	static final byte COMMA     = 34; // ','
	static final byte ASOCIATE  = 35; // ':='
	static final byte LBRACKET  = 36; // lewy nawias
	static final byte RBRACKET  = 37; // prawy nawias
	static final byte QUOTATION = 38; // cudzysw

	// kody dla kategorii
	static final byte KEYWORD   = 60;
	static final byte VARIABLE  = 61;
	static final byte VTYPE     = 62; // typ zmienncyh
	static final byte LOPERATOR = 63; // operator logiczny
	static final byte AOPERATOR = 64; // operator arytmetyczny
	static final byte ROPERATOR = 65; // operator relacji
	static final byte OOPERATOR = 66; // inne operatory
	static final byte NUMBER    = 67;
	
	static final byte INUMBER   =  1; // liczba integer
	static final byte RNUMBER   =  2; // liczba real
	static final byte WORD      =  3;
	static final byte SIGN      =  4;
	static final byte STRING    =  5;

	public ArrayList keywords = new ArrayList();;
	private ArrayList signs = new ArrayList();;

	public void fillLists() {
		keywords.add("PROGRAM");
		keywords.add("BEGIN");
		keywords.add("END");
		keywords.add("END.");
		keywords.add("VAR");
		keywords.add("IF");
		keywords.add("THEN");
		keywords.add("ELSE");
		keywords.add("WHILE");
		keywords.add("DO");
		keywords.add("NOT");
		keywords.add("READLN");
		keywords.add("WRITELN");
		keywords.add("INTEGER");
		keywords.add("REAL");

		signs.add("+");
		signs.add("-");
		signs.add("*");
		signs.add("/");
		signs.add("=");
		signs.add(">");
		signs.add("<");
		signs.add(":");
		signs.add(";");
		signs.add(",");
		signs.add(":=");
		signs.add("(");
		signs.add(")");
	}

	public byte getKeywordCode(String value) {
		int index = keywords.indexOf(value);
		if (index == -1)
			return VARIABLE;
		else 
			return (byte)(10 + index);
	}

	public byte getSignCode(String value) {
		return (byte)(25 + signs.indexOf(value));
	}
}